(function( $ ) {

    var prefix = 'gamipress_wpa_importer_';

    var current_process = 0;
    var process = [
        'achievements',
        'quests',
        'points',
        'ranks',
        'earnings'
    ];

    function gamipress_wpa_migrate() {

        if( process[current_process] === undefined ) {
            // Enable the import button
            $('#' + prefix + 'run').prop('disabled', false);

            // Remove the spinner
            $('#' + prefix + 'response').find('.spinner').remove();

            // Show the success message
            $('#' + prefix + 'response').append( '<br>Process finished succesfully!' );
            return;
        } else {
            $('#' + prefix + 'response').append( '<br>Migrating ' + process[current_process] + '...' );
        }

        $.ajax({
            url: ajaxurl,
            data: {
                action: prefix + 'import_'+ process[current_process],
                // Tool data
                achievements_achievement_type: $('#' + prefix + 'achievements_achievement_type').val(),
                quests_achievement_type: $('#' + prefix + 'quests_achievement_type').val(),
                points_points_type: $('#' + prefix + 'points_points_type').val(),
                ranks_rank_type: $('#' + prefix + 'ranks_rank_type').val()
            },
            success: function( response ) {

                $('#' + prefix + 'response').append( '<br>' + response.data );

                current_process++;

                setTimeout( gamipress_wpa_migrate, 500 );
            },
            error: function( response ) {
                //$('#' + prefix + 'response').css({color:'#a00'});
                $('#' + prefix + 'response').append( '<br>' + '<span style="color: #a00;">' + response.data !== undefined ? response.data : 'Internal server error' + '</span>' );
                return;
            }
        });
    }

    $('#' + prefix + 'run').click(function(e) {
        e.preventDefault();

        var $this = $(this);

        // Disable the import button
        $this.prop('disabled', true);

        // Show the spinner
        $this.parent().append('<div id="' + prefix + 'response"><span class="spinner is-active" style="float: none;"></span></div>');

        gamipress_wpa_migrate();
    });

})( jQuery );